#include <stdlib.h>
#include <stdio.h>
#include "handler.h"

int main(int argc, char *argv[]) {
    size_t count;
    char *path_name;
    warc_handler_t handler;
    warc_record_t record;

    /* get the path name */
    if (argc != 2) {
        fputs("usage: example file.warc\n", stderr);
        return EXIT_FAILURE;
    }
    path_name = argv[1];

    /* open */
    if (!warc_handler_new(&handler, path_name)) {
        fputs("warc_handler_new\n", stderr);
        return EXIT_FAILURE;
    }

    /* read loop */
    for (count = 0;; count++) {
        int ret;

        /* parse the next record */
        ret = warc_handler_next_record(&handler, &record);

        /* on error */
        if (ret == 0) {
            fputs("warc_handler_next_raw_record\n", stderr);
            return EXIT_FAILURE;
        }
        /* on EOF */
        else if (ret == -1) {
            break;
        }

        /* dump some information */
#define X(field)                                                        \
        printf("# %-14s%.*s\n", #field, (int)(record.field.end - record.field.start), record.field.start);
        WARC_RECORD_FIELDS;
#undef X
        printf("\n%.*s\n", (int)(record.payload.end - record.payload.start), record.payload.start);
    }

    /* dump the number of records parsed */
    printf("# %lu records parsed\n", count);

    /* close */
    if (!warc_handler_del(&handler)) {
        fputs("warc_handler_new\n", stderr);
        return EXIT_FAILURE;
    }

    return EXIT_SUCCESS;
}
