#ifndef WARC_HANDLER_H
#define WARC_HANDLER_H

#include <stdlib.h>
#include <stddef.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <fcntl.h>
#include <sys/mman.h>
#include "record.h"

typedef struct
{
    /* file descriptor of the file */
    int file_descr;

    /* extended information of the file */
    struct stat stat_info;

    /* base and current pointers in the mmapped file */
    char const *base_prt;
    char const *current_prt;
}
warc_handler_t;

/* initialize a new handler */
int warc_handler_new(warc_handler_t *handler, char const *path_name);

/* finalize an handler */
int warc_handler_del(warc_handler_t *handler);

/* fill record with the next record read in the file */
int warc_handler_next_record(warc_handler_t *handler, warc_record_t *record);

#endif
