#define _GNU_SOURCE
#include <string.h>
#include <ctype.h>
#include "record.h"

#define SEPARATOR "\r\n\r\n"
#define SEPARATOR_LENGTH (sizeof(SEPARATOR) - 1)

static int
skip(char const **pointer, char const *up_to, int skip_spaces)
{
    while (!(skip_spaces ^ !!isspace(**pointer))) { /* used to negate the check note isspace() return 0 or nonzero (i.e. in principle NOT 1)*/
        (*pointer)++;
        if (*pointer >= up_to) {
            return 0;
        }
    }
    return 1;
}

static int
next_token(char const **start, char const **end, char const *up_to)
{
    /* skip spaces */
    *start = *end;
    if (!skip(start, up_to, 1)) {
        return 0;
    }

    /* skip not spaces */
    *end = *start;
    if (!skip(end, up_to, 0)) {
        return 0;
    }

    return 1;
}

#define NEXT_TOKEN(field)                                        \
    do {                                                         \
        if (!next_token(&start, &end, record->storage.end)) {    \
            return 0;                                            \
        }                                                        \
        record->field.start = start;                             \
        record->field.end = end;                                 \
    } while (0)

int
warc_record_update(warc_record_t *record)
{
    char const *start;
    char const *end;

    start = end = record->storage.start;

    /* tokenize and assign fields */
#define X(field) NEXT_TOKEN(field);
    WARC_RECORD_FIELDS;
#undef X

    /* locate the payload */
    start = memmem(end, record->storage.end - end, SEPARATOR, SEPARATOR_LENGTH);
    if (!start) {
        return 0;
    }
    end = record->storage.end - SEPARATOR_LENGTH; /* TODO actually not according to the spec */
    record->payload.start = start + SEPARATOR_LENGTH;
    record->payload.end = end;

    return 1;
}
