#ifndef WARC_RECORD_H
#define WARC_RECORD_H

#include <stddef.h>

#define WARC_RECORD_FIELDS                      \
    X(version)                                  \
    X(length)                                   \
    X(record_type)                              \
    X(uri)                                      \
    X(creation_date)                            \
    X(content_type)                             \
    X(record_id)

typedef struct
{
    char const *start;
    char const *end;
}
warc_pointer_t;

typedef struct
{
    warc_pointer_t storage;

#define X(field) warc_pointer_t field;
    WARC_RECORD_FIELDS
#undef X

    warc_pointer_t payload;
}
warc_record_t;

/* update the fields of this record using its own storage */
int warc_record_update(warc_record_t *record);

#endif
